VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.3#0"; "COMCTL32.OCX"
Begin VB.Form frmPicGS 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Picture-Converter for Greyscale Pictures"
   ClientHeight    =   2790
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4215
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "frmPicGS.frx":0000
   LinkTopic       =   "Form2"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   186
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   281
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton Command1 
      Caption         =   "Make Gpic83 Pic"
      Height          =   375
      Left            =   1200
      TabIndex        =   12
      Top             =   2040
      Width           =   855
   End
   Begin VB.CheckBox chkCompressRLE 
      Caption         =   "RLE Compression with:"
      Height          =   255
      Left            =   120
      TabIndex        =   11
      Top             =   2520
      Width           =   1935
   End
   Begin VB.OptionButton optRLEBytes 
      Caption         =   "Bytes"
      Height          =   255
      Left            =   2160
      TabIndex        =   10
      Top             =   2520
      Value           =   -1  'True
      Width           =   855
   End
   Begin VB.OptionButton optRLEBits 
      Caption         =   "Bits"
      Enabled         =   0   'False
      Height          =   255
      Left            =   3120
      TabIndex        =   9
      Top             =   2520
      Width           =   855
   End
   Begin VB.CommandButton cmdSave 
      Caption         =   "Save picture as grey"
      Height          =   375
      Left            =   2160
      TabIndex        =   6
      Top             =   1200
      Width           =   1935
   End
   Begin VB.TextBox txtSource 
      Height          =   285
      Left            =   120
      Locked          =   -1  'True
      TabIndex        =   4
      Top             =   1680
      Width           =   1935
   End
   Begin VB.CommandButton cmdLoad 
      Caption         =   "Load picture"
      Height          =   375
      Left            =   120
      TabIndex        =   3
      Top             =   1200
      Width           =   1935
   End
   Begin VB.PictureBox picUnchanged 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H80000005&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   960
      Left            =   120
      MouseIcon       =   "frmPicGS.frx":08CA
      MousePointer    =   99  'Custom
      ScaleHeight     =   64
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   128
      TabIndex        =   2
      Top             =   120
      Width           =   1920
   End
   Begin VB.CommandButton cmdConvert_Save 
      Caption         =   "Convert && Save"
      Height          =   375
      Left            =   120
      TabIndex        =   1
      Top             =   2040
      Width           =   975
   End
   Begin VB.PictureBox picConverted 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H80000005&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   960
      Left            =   2160
      MouseIcon       =   "frmPicGS.frx":1194
      MousePointer    =   99  'Custom
      ScaleHeight     =   64
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   128
      TabIndex        =   0
      Top             =   120
      Width           =   1920
   End
   Begin ComctlLib.ProgressBar prgLoad 
      Height          =   135
      Left            =   2160
      TabIndex        =   5
      Top             =   2280
      Width           =   1935
      _ExtentX        =   3413
      _ExtentY        =   238
      _Version        =   327682
      Appearance      =   1
      Max             =   63
   End
   Begin ComctlLib.Slider sliSetting 
      Height          =   255
      Left            =   2160
      TabIndex        =   7
      ToolTipText     =   "slide to make it brighter/darker"
      Top             =   1680
      Width           =   1935
      _ExtentX        =   3413
      _ExtentY        =   450
      _Version        =   327682
      Max             =   100
      SelStart        =   50
      TickFrequency   =   5
      Value           =   50
   End
   Begin MSComDlg.CommonDialog cdlLoad 
      Left            =   0
      Top             =   1920
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Label lblValue 
      Alignment       =   2  'Center
      Caption         =   "50 %"
      Height          =   255
      Left            =   2280
      TabIndex        =   8
      Top             =   1920
      Width           =   1815
   End
End
Attribute VB_Name = "frmPicGS"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim Num As Integer

Const White = 16777215
Const Light = 12632256
Const Dark = 8421504
Const Black = 0
Dim LightBorder, MiddleBorder, DarkBorder As Long

Dim Heck() As Integer     'Dark Layer    (x,y)
Dim Dunkel() As Integer   'Light Layer   (x,y)
Dim Lines() As String     'Lines         (Layer,y)

Private Sub cmdLoad_Click()

 With cdlLoad
 .DialogTitle = "Select picture to open"
 .InitDir = CurDir
 .Filter = "Pictures (*.bmp;*.gif;*.jpg;*.ico)|*.bmp;*.gif;*.jpg;*.ico"
 .FileName = ""
 .ShowOpen
 End With
 If cdlLoad.FileName = "" Then Exit Sub
 txtSource = cdlLoad.FileName
 picUnchanged = LoadPicture(txtSource)
 Convert
 
End Sub

Function Convert()
  
 MiddleBorder = White / 100 * sliSetting.Value + 100000
 DarkBorder = MiddleBorder / 3
 LightBorder = (White - MiddleBorder) / 3 * 2 + MiddleBorder

 ReDim Heck(127, 63)
 ReDim Dunkel(127, 63)
 ReDim Lines(1, 63)

 For Y = 0 To 63
  prgLoad.Value = Y
  For X = 0 To 127
   If picUnchanged.Point(X, Y) > LightBorder Then Heck(X, Y) = 0: Dunkel(X, Y) = 0: picConverted.PSet (X, Y), White
   If picUnchanged.Point(X, Y) < LightBorder And picUnchanged.Point(X, Y) > MiddleBorder Then Heck(X, Y) = 1: Dunkel(X, Y) = 0: picConverted.PSet (X, Y), Light
   If picUnchanged.Point(X, Y) < MiddleBorder And picUnchanged.Point(X, Y) > DarkBorder Then Heck(X, Y) = 0: Dunkel(X, Y) = 1: picConverted.PSet (X, Y), Dark
   If picUnchanged.Point(X, Y) < DarkBorder Then Heck(X, Y) = 1: Dunkel(X, Y) = 1: picConverted.PSet (X, Y), Black
  Next X
 Next Y
 prgLoad.Value = 0
 
End Function

Private Sub cmdConvert_Save_Click()

 With cdlLoad
  .DialogTitle = "Save the picture"
  .InitDir = CurDir
  .Filter = "Binary Data (*.inc;*.asm;*.txt)|*.inc;*.asm;*.txt"
  .FileName = ""
  .ShowSave
 End With
 If cdlLoad.FileName = "" Then Exit Sub
 file$ = cdlLoad.FileName

 If chkCompressRLE.Value = False Then
  
  For Layers = 0 To 1
   For Y = 0 To 63
    Lines(Layers, Y) = " .db "
    For X = 0 To 15
     Lines(Layers, Y) = Lines(Layers, Y) + "%"
     For b = 0 To 7
      If Layers = 0 Then
       Lines(Layers, Y) = Lines(Layers, Y) + Trim(Str$(Heck(X * 8 + b, Y)))
      Else
       Lines(Layers, Y) = Lines(Layers, Y) + Trim(Str$(Dunkel(X * 8 + b, Y)))
      End If
     Next b
     If X * 8 + b <> 128 Then Lines(Layers, Y) = Lines(Layers, Y) + ","
    Next X
   Next Y
  Next Layers

  Open file$ For Output As #1
   Print #1, ";Created with the Assembly Toolbox by Spooky"
   Print #1, ""
   Print #1, "LightLayer:"
   For t = 0 To 63
    Print #1, Lines(0, t)
   Next t
 
   Print #1, ""
 
   Print #1, "DarkLayer:"
   For t = 0 To 63
    Print #1, Lines(1, t)
   Next t
  Close #1

 Else

  For Layers = 0 To 1
   For Y = 0 To 63
    For X = 0 To 127
      If Layers = 0 Then
       Lines(Layers, Y) = Lines(Layers, Y) + Trim(Str$(Heck(X, Y)))
      Else
       Lines(Layers, Y) = Lines(Layers, Y) + Trim(Str$(Dunkel(X, Y)))
      End If
    Next X
   Next Y
  Next Layers

  For r = 0 To 63
   HeckData$ = HeckData$ + Lines(0, r)
   DunkelData$ = DunkelData$ + Lines(1, r)
  Next r
 
  Dim PicHeck(1024), PicDunkel(1024) As String
  Dim Bytes, Bytes2 As Byte
  
  For f = 0 To 1023
   For Bits = 7 To 0 Step -1
    Bytes = Bytes + Val(Mid(HeckData$, f * 8 + 1 + (7 - Bits), 1)) * (2 ^ Bits)
    Bytes2 = Bytes2 + Val(Mid(DunkelData$, f * 8 + 1 + (7 - Bits), 1)) * (2 ^ Bits)
   Next Bits
   PicHeck(f) = LCase(Hex(Bytes))
   PicDunkel(f) = LCase(Hex(Bytes2))
   Bytes = 0
   Bytes2 = 0
   If Len(PicHeck(f)) = 1 Then PicHeck(f) = "0" + PicHeck(f)
   If Len(PicDunkel(f)) = 1 Then PicDunkel(f) = "0" + PicDunkel(f)
  Next f

Open file$ For Output As #1

Print #1, ";Created with the Assembly Toolbox by Spooky"
Print #1, ""
Print #1, "LightLayer:"

Size = 0
Run = 1
Last = PicHeck(0)

For X = 1 To 1024
    If X <> 1024 And PicHeck(X) = Last And Run < 255 Then
        Run = Run + 1
    Else
        If Run > 2 Or Last = "91" Then
            Fill ("91")
            Fill (Last)
            Fill (LCase(Hex(Run)))
            Size = Size + 3
        Else
            Fill (Last)
            Size = Size + 1
            If Run = 2 Then
                Fill (Last)
                Size = Size + 1
            End If
        End If
        If X <> 1024 Then
         Run = 1
         Last = PicHeck(X)
        End If
    End If
Next X

Print #1, vbCrLf + vbCrLf + ";1024 bytes compressed to " & Size & " -- " & Int((100 * Size) / 1024) & "% of original."

Print #1, ""
Print #1, "DarkLayer:"

Num = 0

Size = 0
Run = 1
Last = PicDunkel(0)

For X = 1 To 1024
    If X <> 1024 And PicDunkel(X) = Last And Run < 255 Then
        Run = Run + 1
    Else
        If Run > 2 Or Last = "91" Then
            Fill ("91")
            Fill (Last)
            Fill (LCase(Hex(Run)))
            Size = Size + 3
        Else
            Fill (Last)
            Size = Size + 1
            If Run = 2 Then
                Fill (Last)
                Size = Size + 1
            End If
        End If
        If X <> 1024 Then
         Run = 1
         Last = PicDunkel(X)
        End If
    End If
Next X

Print #1, vbCrLf + vbCrLf + ";1024 bytes compressed to " & Size & " -- " & Int((100 * Size) / 1024) & "% of original."

Close #1

 End If

End Sub

Private Function Fill(Value As String)

 If Len(Value) = 1 Then Value = "0" + Value
 
  If Num Mod 12 = 0 Then
   Print #1, vbCrLf + " .db $" + Value;
  Else
   Print #1, ",$" + Value;
  End If
  
  Num = Num + 1

End Function

Private Sub Command1_Click()

 With cdlLoad
  .DialogTitle = "Save the picture"
  .InitDir = CurDir
  .Filter = "Binary Data (*.inc;*.asm;*.txt)|*.inc;*.asm;*.txt"
  .FileName = ""
  .ShowSave
 End With
 If cdlLoad.FileName = "" Then Exit Sub
 file$ = cdlLoad.FileName

 If chkCompressRLE.Value = False Then
  
  For Layers = 0 To 1
   For Y = 0 To 63
    Lines(Layers, Y) = " .db "
    For X = 0 To 15
     Lines(Layers, Y) = Lines(Layers, Y) + "%"
     For b = 0 To 7
      If Layers = 0 Then
       Lines(Layers, Y) = Lines(Layers, Y) + Trim(Str$(Heck(X * 8 + b, Y)))
      Else
       Lines(Layers, Y) = Lines(Layers, Y) + Trim(Str$(Dunkel(X * 8 + b, Y)))
      End If
     Next b
     If X * 8 + b <> 128 Then Lines(Layers, Y) = Lines(Layers, Y) + ","
    Next X
   Next Y
  Next Layers

  Open file$ For Output As #1
pic_title = InputBox("Enter the on-calculator picture title", "Pick Pic Title", "MyPic")
Print #1, "        ret"
Print #1, "        .db " & vbquote & "GPic83" & vbquote & ",0                  ;detect string"
Print #1, "  .db " & Len(pic_title) + 1 & "             ;name length (bytes)"
Print #1, "  .db " & vbquote & pic_title & vbquote & ",0         ;image name"
Print #1, "  .db $03             ;number of layers"
Print #1, "  .db 62             ;image height"
Print #1, "  .db 12             ;image width (bytes) (pixels/8)"
Print #1, "  .dw 0016           ;total size (bytes) (height*width(bytes))"
Print #1, ";Layer 1"
   For t = 0 To 63
    Print #1, Lines(0, t)
   Next t
 
   Print #1, ";Layer 2"
   For t = 0 To 63
    Print #1, Lines(1, t)
   Next t
   
    Print #1, ";Layer 3"
   For t = 0 To 63
    Print #1, Lines(1, t)
   Next t
  Close #1

 Else

  For Layers = 0 To 1
   For Y = 0 To 63
    For X = 0 To 127
      If Layers = 0 Then
       Lines(Layers, Y) = Lines(Layers, Y) + Trim(Str$(Heck(X, Y)))
      Else
       Lines(Layers, Y) = Lines(Layers, Y) + Trim(Str$(Dunkel(X, Y)))
      End If
    Next X
   Next Y
  Next Layers

  For r = 0 To 63
   HeckData$ = HeckData$ + Lines(0, r)
   DunkelData$ = DunkelData$ + Lines(1, r)
  Next r
 
  Dim PicHeck(1024), PicDunkel(1024) As String
  Dim Bytes, Bytes2 As Byte
  
  For f = 0 To 1023
   For Bits = 7 To 0 Step -1
    Bytes = Bytes + Val(Mid(HeckData$, f * 8 + 1 + (7 - Bits), 1)) * (2 ^ Bits)
    Bytes2 = Bytes2 + Val(Mid(DunkelData$, f * 8 + 1 + (7 - Bits), 1)) * (2 ^ Bits)
   Next Bits
   PicHeck(f) = LCase(Hex(Bytes))
   PicDunkel(f) = LCase(Hex(Bytes2))
   Bytes = 0
   Bytes2 = 0
   If Len(PicHeck(f)) = 1 Then PicHeck(f) = "0" + PicHeck(f)
   If Len(PicDunkel(f)) = 1 Then PicDunkel(f) = "0" + PicDunkel(f)
  Next f

Open file$ For Output As #1

Print #1, ";Created with the Assembly Toolbox by Spooky"
Print #1, ""
Print #1, "LightLayer:"

Size = 0
Run = 1
Last = PicHeck(0)

For X = 1 To 1024
    If X <> 1024 And PicHeck(X) = Last And Run < 255 Then
        Run = Run + 1
    Else
        If Run > 2 Or Last = "91" Then
            Fill ("91")
            Fill (Last)
            Fill (LCase(Hex(Run)))
            Size = Size + 3
        Else
            Fill (Last)
            Size = Size + 1
            If Run = 2 Then
                Fill (Last)
                Size = Size + 1
            End If
        End If
        If X <> 1024 Then
         Run = 1
         Last = PicHeck(X)
        End If
    End If
Next X

Print #1, vbCrLf + vbCrLf + ";1024 bytes compressed to " & Size & " -- " & Int((100 * Size) / 1024) & "% of original."

Print #1, ""
Print #1, "DarkLayer:"

Num = 0

Size = 0
Run = 1
Last = PicDunkel(0)

For X = 1 To 1024
    If X <> 1024 And PicDunkel(X) = Last And Run < 255 Then
        Run = Run + 1
    Else
        If Run > 2 Or Last = "91" Then
            Fill ("91")
            Fill (Last)
            Fill (LCase(Hex(Run)))
            Size = Size + 3
        Else
            Fill (Last)
            Size = Size + 1
            If Run = 2 Then
                Fill (Last)
                Size = Size + 1
            End If
        End If
        If X <> 1024 Then
         Run = 1
         Last = PicDunkel(X)
        End If
    End If
Next X

Print #1, vbCrLf + vbCrLf + ";1024 bytes compressed to " & Size & " -- " & Int((100 * Size) / 1024) & "% of original."

Close #1

 End If

End Sub

Private Sub sliSetting_Change()

 Convert
 
End Sub

Private Sub sliSetting_Scroll()

 lblValue = sliSetting.Value & " %"
 
End Sub

Private Sub picConverted_Click()
 frmZoom.imgZoom.Picture = picConverted.Image
 frmZoom.Show 1, Me
End Sub

Private Sub picUnchanged_Click()
 frmZoom.imgZoom.Picture = picUnchanged.Image
 frmZoom.Show 1, Me
End Sub

Private Sub cmdSave_Click()

 If txtSource <> "" Then
  With cdlLoad
   .DialogTitle = "Save the picture as Bitmap"
   .InitDir = CurDir
   .Filter = "Bitmap (*.bmp)|*.bmp"
   .FileName = ""
   .ShowSave
  End With
  If cdlLoad.FileName = "" Then Exit Sub
  file$ = cdlLoad.FileName
  SavePicture picConverted.Image, file$
 End If
End Sub

