VERSION 5.00
Begin VB.Form frmSprBW 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Sprite-Editor for Black&White Sprites"
   ClientHeight    =   3555
   ClientLeft      =   1815
   ClientTop       =   3180
   ClientWidth     =   6750
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "frmSprBW.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   237
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   450
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton cmdClear 
      Caption         =   "&Clear"
      Height          =   375
      Left            =   2880
      TabIndex        =   4
      Top             =   2400
      Width           =   615
   End
   Begin VB.PictureBox picPen 
      BackColor       =   &H00000000&
      Height          =   495
      Left            =   2520
      ScaleHeight     =   435
      ScaleWidth      =   435
      TabIndex        =   1
      Top             =   1440
      Width           =   495
   End
   Begin VB.TextBox txtCode 
      Height          =   2055
      Left            =   120
      MultiLine       =   -1  'True
      TabIndex        =   6
      Top             =   120
      Width           =   2055
   End
   Begin VB.PictureBox picPreview 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H80000005&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   1200
      Left            =   2280
      ScaleHeight     =   80
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   80
      TabIndex        =   5
      Top             =   120
      Width           =   1200
   End
   Begin VB.CommandButton cmdClipboard 
      Caption         =   "C&opy"
      Height          =   375
      Left            =   2280
      TabIndex        =   3
      Top             =   2400
      Width           =   615
   End
   Begin VB.PictureBox picPen2 
      BackColor       =   &H00FFFFFF&
      Height          =   495
      Left            =   2760
      ScaleHeight     =   435
      ScaleWidth      =   435
      TabIndex        =   2
      Top             =   1680
      Width           =   495
   End
   Begin VB.PictureBox picSprite 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H80000005&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   3000
      Left            =   3600
      ScaleHeight     =   80
      ScaleMode       =   0  'User
      ScaleWidth      =   80
      TabIndex        =   0
      Top             =   120
      Width           =   3000
   End
   Begin VB.Label lblHelp 
      Caption         =   $"frmSprBW.frx":08CA
      Height          =   1215
      Left            =   120
      TabIndex        =   7
      Top             =   2280
      Width           =   2055
   End
End
Attribute VB_Name = "frmSprBW"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Const White = 16777215
Const Black = 0

Dim Map(7, 7) As Integer

Private Sub cmdClear_Click()
 picSprite.Cls
 picPreview.Cls
 ConverttoText
End Sub

Function ConverttoPict()

 If Len(txtCode) < 64 Then Exit Function

 For check = 1 To Len(txtCode)
  If Mid(txtCode, check, 1) = "0" Or Mid(txtCode, check, 1) = "1" Then textData$ = textData$ + Mid(txtCode, check, 1)
 Next check
  
 Debug.Print textData$
  
 If Len(textData$) < 64 Then Exit Function

 For Y = 0 To 7
  For X = 0 To 7
   picSprite.Line (X * 10, Y * 10)-(X * 10 + 10, Y * 10 + 10), (White * Val(1 - Mid$(textData$, Y * 8 + X + 1, 1))), BF
   picPreview.Line (X * 10, Y * 10)-(X * 10 + 10, Y * 10 + 10), (White * Val(1 - Mid$(textData$, Y * 8 + X + 1, 1))), BF
  Next X
 Next Y

End Function

Function ConverttoText()

 For Y = 0 To 7
  For X = 0 To 7
   If picSprite.Point(X * 10 + 1, Y * 10 + 1) = White Then Map(X, Y) = 0
   If picSprite.Point(X * 10 + 1, Y * 10 + 1) = Black Then Map(X, Y) = 1
  Next X
 Next Y

 txtCode = ";Bitmap"
 For Y = 0 To 7: txtCode = txtCode & vbCrLf & ".db %"
  For X = 0 To 7
   txtCode = txtCode & Map(X, Y)
  Next X
 Next Y
End Function

Private Sub cmdClipboard_Click()
 Clipboard.SetText txtCode.Text, vbCFText
End Sub

Private Sub Form_Load()
 ConverttoText
End Sub

Private Sub picWhite_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
 If Button = 1 Then picPen.BackColor = White
 If Button = 2 Then picPen2.BackColor = White
End Sub

Private Sub picBlack_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
 If Button = 1 Then picPen.BackColor = Black
 If Button = 2 Then picPen2.BackColor = Black
End Sub

Private Sub picSprite_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
 If Button = 1 Then
  picSprite.Line (Int(X / 10) * 10, Int(Y / 10) * 10)-(Int(X / 10) * 10 + 9.5, Int(Y / 10) * 10 + 9.5), picPen.BackColor, BF
  picPreview.Line (Int(X / 10) * 10, Int(Y / 10) * 10)-(Int(X / 10) * 10 + 9.5, Int(Y / 10) * 10 + 9.5), picPen.BackColor, BF
 ElseIf Button = 2 Then
  picSprite.Line (Int(X / 10) * 10, Int(Y / 10) * 10)-(Int(X / 10) * 10 + 9.5, Int(Y / 10) * 10 + 9.5), picPen2.BackColor, BF
  picPreview.Line (Int(X / 10) * 10, Int(Y / 10) * 10)-(Int(X / 10) * 10 + 9.5, Int(Y / 10) * 10 + 9.5), picPen2.BackColor, BF
 End If
End Sub

Private Sub picSprite_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
 If Button = 1 Then
  picSprite.Line (Int(X / 10) * 10, Int(Y / 10) * 10)-(Int(X / 10) * 10 + 9.5, Int(Y / 10) * 10 + 9.5), picPen.BackColor, BF
  picPreview.Line (Int(X / 10) * 10, Int(Y / 10) * 10)-(Int(X / 10) * 10 + 9.5, Int(Y / 10) * 10 + 9.5), picPen.BackColor, BF
 ElseIf Button = 2 Then
  picSprite.Line (Int(X / 10) * 10, Int(Y / 10) * 10)-(Int(X / 10) * 10 + 9.5, Int(Y / 10) * 10 + 9.5), picPen2.BackColor, BF
  picPreview.Line (Int(X / 10) * 10, Int(Y / 10) * 10)-(Int(X / 10) * 10 + 9.5, Int(Y / 10) * 10 + 9.5), picPen2.BackColor, BF
 End If
End Sub

Private Sub picSprite_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
 ConverttoText
End Sub

Private Sub txtCode_DblClick()
 ConverttoPict
End Sub

Private Sub vscHeight_Change()
 txtHeight = vscHeight.Value
 picSprite.ScaleHeight = txtHeight * 10
 picPreview.ScaleHeight = txtHeight * 10
End Sub

Private Sub vscWidth_Change()
 txtWidth = vscWidth.Value
 picSprite.ScaleWidth = txtWidth * 10
 picPreview.ScaleWidth = txtWidth * 10
End Sub
