VERSION 5.00
Begin VB.Form frmSprGS 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Sprite-Editor for Greyscale Sprites"
   ClientHeight    =   4290
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6360
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "frmSprGS.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   286
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   424
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.PictureBox picSprite 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H80000005&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   3000
      Left            =   3240
      ScaleHeight     =   80
      ScaleMode       =   0  'User
      ScaleWidth      =   80
      TabIndex        =   10
      Top             =   120
      Width           =   3000
   End
   Begin VB.PictureBox picPen 
      BackColor       =   &H00000000&
      Height          =   495
      Left            =   2400
      ScaleHeight     =   435
      ScaleWidth      =   435
      TabIndex        =   7
      Top             =   1440
      Width           =   495
   End
   Begin VB.PictureBox picPen2 
      BackColor       =   &H00FFFFFF&
      Height          =   495
      Left            =   2640
      ScaleHeight     =   435
      ScaleWidth      =   435
      TabIndex        =   9
      Top             =   1680
      Width           =   495
   End
   Begin VB.CommandButton cmdClipboard 
      Caption         =   "C&opy"
      Height          =   375
      Left            =   2400
      TabIndex        =   8
      Top             =   2880
      Width           =   735
   End
   Begin VB.CommandButton cmdClear 
      Caption         =   "&Clear"
      Height          =   375
      Left            =   2400
      TabIndex        =   6
      Top             =   2400
      Width           =   735
   End
   Begin VB.PictureBox picPreview 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H80000005&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   1200
      Left            =   1920
      ScaleHeight     =   80
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   80
      TabIndex        =   5
      Top             =   120
      Width           =   1200
   End
   Begin VB.PictureBox picWhite 
      BackColor       =   &H00FFFFFF&
      Height          =   375
      Left            =   1920
      ScaleHeight     =   315
      ScaleWidth      =   315
      TabIndex        =   4
      Top             =   1440
      Width           =   375
   End
   Begin VB.PictureBox picLight 
      Height          =   375
      Left            =   1920
      ScaleHeight     =   315
      ScaleWidth      =   315
      TabIndex        =   3
      Top             =   1920
      Width           =   375
   End
   Begin VB.PictureBox picDark 
      BackColor       =   &H00808080&
      Height          =   375
      Left            =   1920
      ScaleHeight     =   315
      ScaleWidth      =   315
      TabIndex        =   2
      Top             =   2400
      Width           =   375
   End
   Begin VB.PictureBox picBlack 
      BackColor       =   &H00000000&
      Height          =   375
      Left            =   1920
      ScaleHeight     =   315
      ScaleWidth      =   315
      TabIndex        =   1
      Top             =   2880
      Width           =   375
   End
   Begin VB.TextBox txtCode 
      Height          =   3975
      Left            =   120
      MultiLine       =   -1  'True
      TabIndex        =   0
      Top             =   120
      Width           =   1695
   End
   Begin VB.Label lblHelp 
      Caption         =   $"frmSprGS.frx":08CA
      Height          =   855
      Left            =   1920
      TabIndex        =   11
      Top             =   3360
      Width           =   4335
   End
End
Attribute VB_Name = "frmSprGS"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Const White = 16777215
Const Light = 12632256
Const Dark = 8421504
Const Black = 0

Dim Heck(7, 7) As Integer
Dim Dunkel(7, 7) As Integer

Private Sub cmdClear_Click()
 picSprite.Cls
 picPreview.Cls
 ConverttoText
End Sub

Function ConverttoPict()

If Len(txtCode) < 128 Then Exit Function

 For check = 1 To Len(txtCode)
  If Mid(txtCode, check, 1) = "0" Or Mid(txtCode, check, 1) = "1" Then textData$ = textData$ + Mid(txtCode, check, 1)
 Next check
 If Len(textData$) < 128 Then Exit Function

 Do
  Pos = Pos + 1
  LightData$ = LightData$ + Mid(textData$, Pos, 1)
 Loop Until Len(LightData$) = 64

 Do
  Pos = Pos + 1
  DarkData$ = DarkData$ + Mid(textData$, Pos, 1)
 Loop Until Len(DarkData$) = 64
 
 For Y = 0 To 7
  For X = 0 To 7
   If Val(Mid$(LightData$, Y * 8 + X + 1, 1)) = 0 And Val(Mid$(DarkData$, Y * 8 + X + 1, 1)) = 0 Then
    Col = White
   ElseIf Val(Mid$(LightData$, Y * 8 + X + 1, 1)) = 1 And Val(Mid$(DarkData$, Y * 8 + X + 1, 1)) = 0 Then
    Col = Light
   ElseIf Val(Mid$(LightData$, Y * 8 + X + 1, 1)) = 0 And Val(Mid$(DarkData$, Y * 8 + X + 1, 1)) = 1 Then
    Col = Dark
   Else
    Col = Black
   End If
   picSprite.Line (X * 10, Y * 10)-(X * 10 + 10, Y * 10 + 10), Col, BF
   picPreview.Line (X * 10, Y * 10)-(X * 10 + 10, Y * 10 + 10), Col, BF
  Next X
 Next Y
 
End Function

Function ConverttoText()
 
For Y = 0 To 7
 For X = 0 To 7
  If picSprite.Point(X * 10, Y * 10) = White Then Heck(X, Y) = 0: Dunkel(X, Y) = 0
  If picSprite.Point(X * 10, Y * 10) = Light Then Heck(X, Y) = 1: Dunkel(X, Y) = 0
  If picSprite.Point(X * 10, Y * 10) = Dark Then Heck(X, Y) = 0: Dunkel(X, Y) = 1
  If picSprite.Point(X * 10, Y * 10) = Black Then Heck(X, Y) = 1: Dunkel(X, Y) = 1
 Next X
Next Y

txtCode = ";Light Layer"
For Y = 0 To 7: txtCode = txtCode & vbCrLf & ".db %"
 For X = 0 To 7
  txtCode = txtCode & Heck(X, Y)
 Next X
Next Y

txtCode = txtCode & vbCrLf & vbCrLf & ";Dark Layer"
For Y = 0 To 7: txtCode = txtCode & vbCrLf & ".db %"
 For X = 0 To 7
  txtCode = txtCode & Dunkel(X, Y)
 Next X
Next Y

End Function

Private Sub cmdClipboard_Click()
 Clipboard.SetText txtCode, vbCFText
End Sub

Private Sub Form_Load()
 ConverttoText
End Sub

Private Sub picWhite_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
 If Button = 1 Then picPen.BackColor = White
 If Button = 2 Then picPen2.BackColor = White
End Sub

Private Sub picLight_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
 If Button = 1 Then picPen.BackColor = Light
 If Button = 2 Then picPen2.BackColor = Light
End Sub

Private Sub picDark_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
 If Button = 1 Then picPen.BackColor = Dark
 If Button = 2 Then picPen2.BackColor = Dark
End Sub

Private Sub picBlack_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
 If Button = 1 Then picPen.BackColor = Black
 If Button = 2 Then picPen2.BackColor = Black
End Sub

Private Sub picSprite_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
 If Button = 1 Then
  picSprite.Line (Int(X / 10) * 10, Int(Y / 10) * 10)-(Int(X / 10) * 10 + 9.5, Int(Y / 10) * 10 + 9.5), picPen.BackColor, BF
  picPreview.Line (Int(X / 10) * 10, Int(Y / 10) * 10)-(Int(X / 10) * 10 + 9.5, Int(Y / 10) * 10 + 9.5), picPen.BackColor, BF
 ElseIf Button = 2 Then
  picSprite.Line (Int(X / 10) * 10, Int(Y / 10) * 10)-(Int(X / 10) * 10 + 9.5, Int(Y / 10) * 10 + 9.5), picPen2.BackColor, BF
  picPreview.Line (Int(X / 10) * 10, Int(Y / 10) * 10)-(Int(X / 10) * 10 + 9.5, Int(Y / 10) * 10 + 9.5), picPen2.BackColor, BF
 End If
End Sub

Private Sub picSprite_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
 If Button = 1 Then
  picSprite.Line (Int(X / 10) * 10, Int(Y / 10) * 10)-(Int(X / 10) * 10 + 9.5, Int(Y / 10) * 10 + 9.5), picPen.BackColor, BF
  picPreview.Line (Int(X / 10) * 10, Int(Y / 10) * 10)-(Int(X / 10) * 10 + 9.5, Int(Y / 10) * 10 + 9.5), picPen.BackColor, BF
 ElseIf Button = 2 Then
  picSprite.Line (Int(X / 10) * 10, Int(Y / 10) * 10)-(Int(X / 10) * 10 + 9.5, Int(Y / 10) * 10 + 9.5), picPen2.BackColor, BF
  picPreview.Line (Int(X / 10) * 10, Int(Y / 10) * 10)-(Int(X / 10) * 10 + 9.5, Int(Y / 10) * 10 + 9.5), picPen2.BackColor, BF
 End If
End Sub

Private Sub picSprite_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
 ConverttoText
End Sub

Private Sub txtCode_DblClick()
 ConverttoPict
End Sub
