VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.3#0"; "COMCTL32.OCX"
Begin VB.Form frmPicBW 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Picture-Converter for Black&White Pictures"
   ClientHeight    =   2820
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4215
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "frmPicBW.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   188
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   281
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.OptionButton optRLEBits 
      Caption         =   "Bits"
      Enabled         =   0   'False
      Height          =   255
      Left            =   3120
      TabIndex        =   11
      Top             =   2520
      Width           =   855
   End
   Begin VB.OptionButton optRLEBytes 
      Caption         =   "Bytes"
      Height          =   255
      Left            =   2160
      TabIndex        =   10
      Top             =   2520
      Value           =   -1  'True
      Width           =   855
   End
   Begin VB.CheckBox chkCompressRLE 
      Caption         =   "RLE Compression with:"
      Height          =   255
      Left            =   120
      TabIndex        =   9
      Top             =   2520
      Width           =   1935
   End
   Begin VB.CommandButton cmdSave 
      Caption         =   "Save picture as B&&W"
      Height          =   375
      Left            =   2160
      TabIndex        =   8
      Top             =   1200
      Width           =   1935
   End
   Begin VB.PictureBox picUnchanged 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   960
      Left            =   120
      MouseIcon       =   "frmPicBW.frx":08CA
      MousePointer    =   99  'Custom
      ScaleHeight     =   64
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   128
      TabIndex        =   4
      ToolTipText     =   "Original look"
      Top             =   120
      Width           =   1920
   End
   Begin VB.CommandButton cmdLoad 
      Caption         =   "Load picture"
      Height          =   375
      Left            =   120
      TabIndex        =   3
      ToolTipText     =   "load a picture"
      Top             =   1200
      Width           =   1935
   End
   Begin VB.TextBox txtSource 
      Height          =   285
      Left            =   120
      TabIndex        =   2
      Top             =   1680
      Width           =   1935
   End
   Begin VB.CommandButton cmdConvert_Save 
      Caption         =   "Convert && Save"
      Height          =   375
      Left            =   120
      TabIndex        =   1
      ToolTipText     =   "Convert to Black&White and save"
      Top             =   2040
      Width           =   1935
   End
   Begin VB.PictureBox picConvert 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H80000005&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   960
      Left            =   2160
      MouseIcon       =   "frmPicBW.frx":1194
      MousePointer    =   99  'Custom
      ScaleHeight     =   64
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   128
      TabIndex        =   0
      ToolTipText     =   "Converted preview"
      Top             =   120
      Width           =   1920
   End
   Begin ComctlLib.ProgressBar prgLoad 
      Height          =   135
      Left            =   2160
      TabIndex        =   5
      Top             =   2280
      Width           =   1935
      _ExtentX        =   3413
      _ExtentY        =   238
      _Version        =   327682
      Appearance      =   1
      Max             =   63
   End
   Begin ComctlLib.Slider sliSetting 
      Height          =   255
      Left            =   2160
      TabIndex        =   6
      ToolTipText     =   "slide to make it brighter/darker"
      Top             =   1680
      Width           =   1935
      _ExtentX        =   3413
      _ExtentY        =   450
      _Version        =   327682
      Max             =   100
      SelStart        =   50
      TickFrequency   =   5
      Value           =   50
   End
   Begin MSComDlg.CommonDialog cdlLoad 
      Left            =   0
      Top             =   1920
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Label lblValue 
      Alignment       =   2  'Center
      Caption         =   "50 %"
      Height          =   255
      Left            =   2280
      TabIndex        =   7
      Top             =   1920
      Width           =   1815
   End
End
Attribute VB_Name = "frmPicBW"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim Num As Integer

Private Sub cmdLoad_Click()

 With cdlLoad
  .DialogTitle = "Select picture to open"
  .InitDir = CurDir
  .Filter = "Pictures (*.bmp;*.gif;*.jpg;*.ico)|*.bmp;*.gif;*.jpg;*.ico"
  .FileName = ""
  .ShowOpen
 End With
 If cdlLoad.FileName = "" Then Exit Sub
 txtSource = cdlLoad.FileName
 picUnchanged = LoadPicture(txtSource)
 Convert
 
End Sub

Function Convert()

 picConvert = picUnchanged
 Grenze = 16777214 * sliSetting.Value / 100
 For v = 0 To 63
  prgLoad.Value = v
  For h = 0 To 127
   If picConvert.Point(h, v) < Grenze Then
    picConvert.PSet (h, v), RGB(0, 0, 0)
   ElseIf picConvert.Point(h, v) > Grenze Then
    picConvert.PSet (h, v), RGB(255, 255, 255)
   End If
  Next h
 Next v
 prgLoad.Value = 0
 
End Function

Private Sub cmdConvert_Save_Click()

 With cdlLoad
  .DialogTitle = "Save the picture"
  .InitDir = CurDir
  .Filter = "Binary data (*.inc;*.asm;*.txt)|*.inc;*.asm;*.txt"
  .FileName = ""
  .ShowSave
 End With
 If cdlLoad.FileName = "" Then Exit Sub
 file$ = cdlLoad.FileName

 If chkCompressRLE.Value = False Then
 
  Dim Linie(0 To 63) As String
  For v = 0 To 63
   Linie(v) = Linie(v) + " .db "
   For h = 0 To 15
    Linie(v) = Linie(v) + "%"
    For Bit = 0 To 7
     If picConvert.Point(h * 8 + Bit, v) / 16777215 = 0 Then
      Linie(v) = Linie(v) & "1"
     Else
      Linie(v) = Linie(v) & "0"
     End If
    Next Bit
    Linie(v) = Linie(v) + ","
   Next h
   Linie(v) = Mid$(Linie(v), 1, Len(Linie(v)) - 1)      'Delete the last comma
  Next v

  Open file$ For Output As #1
   Print #1, ";Created with the Assembly Toolbox by Spooky"
   Print #1, ""
   For t = 0 To 63
    Print #1, Linie(t)
   Next t
  Close #1
 
 Else
 
  For Y = 0 To 63
   For X = 0 To 127
    picData$ = picData$ + Trim(Str(1 - (picConvert.Point(X, Y) / 16777215)))
   Next X
  Next Y
   
  Dim Pic(1024) As String
  Dim Bytes As Byte
  
  For f = 0 To 1023
   For Bits = 7 To 0 Step -1
    Bytes = Bytes + Val(Mid(picData$, f * 8 + 1 + (7 - Bits), 1)) * (2 ^ Bits)
   Next Bits
   Pic(f) = LCase(Hex(Bytes))
   Bytes = 0
   If Len(Pic(f)) = 1 Then Pic(f) = "0" + Pic(f)
  Next f
   
Open file$ For Output As #1

Print #1, ";Created with the Assembly Toolbox by Spooky"

Size = 0
Run = 1
Last = Pic(0)

For X = 1 To 1024
    If X <> 1024 And Pic(X) = Last And Run < 255 Then
        Run = Run + 1
    Else
        If Run > 2 Or Last = "91" Then
            Fill ("91")
            Fill (Last)
            Fill (LCase(Hex(Run)))
            Size = Size + 3
        Else
            Fill (Last)
            Size = Size + 1
            If Run = 2 Then
                Fill (Last)
                Size = Size + 1
            End If
        End If
        If X <> 1024 Then
         Run = 1
         Last = Pic(X)
        End If
    End If
Next X

Print #1, vbCrLf + vbCrLf + ";1024 bytes compressed to " & Size & " -- " & Int((100 * Size) / 1024) & "% of original."
Close #1
 
 End If

End Sub

Private Function Fill(Value As String)

 If Len(Value) = 1 Then Value = "0" + Value
 
  If Num Mod 12 = 0 Then
   Print #1, vbCrLf + " .db $" + Value;
  Else
   Print #1, ",$" + Value;
  End If
  
  Num = Num + 1

End Function

Private Sub sliSetting_Change()

 Convert
 
End Sub

Private Sub sliSetting_Scroll()

 lblValue = sliSetting.Value & " %"
 
End Sub

Private Sub picConvert_Click()

 frmZoom.imgZoom.Picture = picConvert.Image
 frmZoom.Show 1, Me
 
End Sub

Private Sub picUnchanged_Click()

 frmZoom.imgZoom.Picture = picUnchanged.Image
 frmZoom.Show 1, Me
 
End Sub

Private Sub cmdSave_Click()

 If txtSource <> "" Then
  With cdlLoad
   .DialogTitle = "Save the picture as Bitmap"
   .InitDir = CurDir
   .Filter = "Bitmap (*.bmp)|*.bmp"
   .FileName = ""
   .ShowSave
  End With
  If cdlLoad.FileName = "" Then Exit Sub
  file$ = cdlLoad.FileName
  SavePicture picConvert.Image, file$
 End If

End Sub
