VERSION 5.00
Begin VB.Form frmSprBWm 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Sprite-Editor for Black&White Sprites with Mask"
   ClientHeight    =   4335
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   7095
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4335
   ScaleWidth      =   7095
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox picWhite 
      BackColor       =   &H00FFFFFF&
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   2400
      ScaleHeight     =   315
      ScaleWidth      =   315
      TabIndex        =   9
      Top             =   1440
      Width           =   375
   End
   Begin VB.PictureBox picBlack 
      BackColor       =   &H00000000&
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   2400
      ScaleHeight     =   315
      ScaleWidth      =   315
      TabIndex        =   8
      Top             =   1920
      Width           =   375
   End
   Begin VB.PictureBox picMask 
      BackColor       =   &H000080FF&
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   2400
      ScaleHeight     =   315
      ScaleWidth      =   315
      TabIndex        =   7
      Top             =   2400
      Width           =   375
   End
   Begin VB.PictureBox picSprite 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H80000005&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   3000
      Left            =   3960
      ScaleHeight     =   80
      ScaleMode       =   0  'User
      ScaleWidth      =   80
      TabIndex        =   6
      Top             =   120
      Width           =   3000
   End
   Begin VB.PictureBox picPen 
      BackColor       =   &H00000000&
      Height          =   495
      Left            =   2880
      ScaleHeight     =   435
      ScaleWidth      =   435
      TabIndex        =   5
      Top             =   1440
      Width           =   495
   End
   Begin VB.PictureBox picPen2 
      BackColor       =   &H00FFFFFF&
      Height          =   495
      Left            =   3120
      ScaleHeight     =   435
      ScaleWidth      =   435
      TabIndex        =   4
      Top             =   1680
      Width           =   495
   End
   Begin VB.CommandButton cmdClipboard 
      Caption         =   "C&opy"
      Height          =   375
      Left            =   2880
      TabIndex        =   3
      Top             =   2760
      Width           =   855
   End
   Begin VB.CommandButton cmdClear 
      Caption         =   "&Clear"
      Height          =   375
      Left            =   2880
      TabIndex        =   2
      Top             =   2280
      Width           =   855
   End
   Begin VB.PictureBox picPreview 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H80000005&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   1200
      Left            =   2400
      ScaleHeight     =   80
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   80
      TabIndex        =   1
      Top             =   120
      Width           =   1200
   End
   Begin VB.TextBox txtCode 
      Height          =   4095
      Left            =   120
      MultiLine       =   -1  'True
      TabIndex        =   0
      Top             =   120
      Width           =   2055
   End
   Begin VB.Label lblHelp 
      Caption         =   $"frmSprBWm.frx":0000
      Height          =   975
      Left            =   2280
      TabIndex        =   10
      Top             =   3240
      Width           =   4695
   End
End
Attribute VB_Name = "frmSprBWm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Const White = 16777215
Const Black = 0
Const Mask = 33023

Dim Map(7, 7) As Integer
Dim Maske(7, 7) As Integer

Private Sub cmdClear_Click()
 picSprite.Cls
 picPreview.Cls
 ConverttoText
End Sub
Function ConverttoPict()

If Len(txtCode) < 128 Then Exit Function

 For check = 1 To Len(txtCode)
  If Mid(txtCode, check, 1) = "0" Or Mid(txtCode, check, 1) = "1" Then textData$ = textData$ + Mid(txtCode, check, 1)
 Next check
 If Len(textData$) < 128 Then Exit Function

 Do
  Pos = Pos + 1
  BitmapData$ = BitmapData$ + Mid(textData$, Pos, 1)
 Loop Until Len(BitmapData$) = 64

 Do
  Pos = Pos + 1
  MaskData$ = MaskData$ + Mid(textData$, Pos, 1)
 Loop Until Len(MaskData$) = 64
 
 For Y = 0 To 7
  For X = 0 To 7
   If Val(Mid$(MaskData$, Y * 8 + X + 1, 1)) = 1 Then   'Either not masked -> Black or White
    Col = White * Val(1 - Mid$(BitmapData$, Y * 8 + X + 1, 1))
   Else                                                 'or masked -> Orange
    Col = Mask
   End If
   picSprite.Line (X * 10, Y * 10)-(X * 10 + 10, Y * 10 + 10), Col, BF
   picPreview.Line (X * 10, Y * 10)-(X * 10 + 10, Y * 10 + 10), Col, BF
  Next X
 Next Y
 
End Function

Function ConverttoText()
 
For Y = 0 To 7
 For X = 0 To 7
  If picSprite.Point(X * 10, Y * 10) = White Then Map(X, Y) = 0: Maske(X, Y) = 1
  If picSprite.Point(X * 10, Y * 10) = Black Then Map(X, Y) = 1: Maske(X, Y) = 1
  If picSprite.Point(X * 10, Y * 10) = Mask Then Map(X, Y) = 0: Maske(X, Y) = 0
 Next X
Next Y

FillText$ = ";Bitmap"
For Y = 0 To 7: FillText$ = FillText$ & vbCrLf & ".db %"
 For X = 0 To 7
  FillText$ = FillText$ & Map(X, Y)
 Next X
Next Y

FillText$ = FillText$ & vbCrLf & vbCrLf & ";Mask Layer"
For Y = 0 To 7: FillText$ = FillText$ & vbCrLf & ".db %"
 For X = 0 To 7
  FillText$ = FillText$ & Maske(X, Y)
 Next X
Next Y

txtCode = FillText$

End Function

Private Sub cmdClipboard_Click()
 Clipboard.SetText txtCode.Text, vbCFText
End Sub

Private Sub Form_Load()
 ConverttoText
End Sub

Private Sub picMask_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
 If Button = 1 Then picPen.BackColor = Mask
 If Button = 2 Then picPen2.BackColor = Mask
End Sub

Private Sub picWhite_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
 If Button = 1 Then picPen.BackColor = White
 If Button = 2 Then picPen2.BackColor = White
End Sub

Private Sub picBlack_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
 If Button = 1 Then picPen.BackColor = Black
 If Button = 2 Then picPen2.BackColor = Black
End Sub

Private Sub picSprite_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
 If Button = 1 Then
  picSprite.Line (Int(X / 10) * 10, Int(Y / 10) * 10)-(Int(X / 10) * 10 + 9.5, Int(Y / 10) * 10 + 9.5), picPen.BackColor, BF
  picPreview.Line (Int(X / 10) * 10, Int(Y / 10) * 10)-(Int(X / 10) * 10 + 9.5, Int(Y / 10) * 10 + 9.5), picPen.BackColor, BF
 ElseIf Button = 2 Then
  picSprite.Line (Int(X / 10) * 10, Int(Y / 10) * 10)-(Int(X / 10) * 10 + 9.5, Int(Y / 10) * 10 + 9.5), picPen2.BackColor, BF
  picPreview.Line (Int(X / 10) * 10, Int(Y / 10) * 10)-(Int(X / 10) * 10 + 9.5, Int(Y / 10) * 10 + 9.5), picPen2.BackColor, BF
 End If
End Sub

Private Sub picSprite_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
 If Button = 1 Then
  picSprite.Line (Int(X / 10) * 10, Int(Y / 10) * 10)-(Int(X / 10) * 10 + 9.5, Int(Y / 10) * 10 + 9.5), picPen.BackColor, BF
  picPreview.Line (Int(X / 10) * 10, Int(Y / 10) * 10)-(Int(X / 10) * 10 + 9.5, Int(Y / 10) * 10 + 9.5), picPen.BackColor, BF
 ElseIf Button = 2 Then
  picSprite.Line (Int(X / 10) * 10, Int(Y / 10) * 10)-(Int(X / 10) * 10 + 9.5, Int(Y / 10) * 10 + 9.5), picPen2.BackColor, BF
  picPreview.Line (Int(X / 10) * 10, Int(Y / 10) * 10)-(Int(X / 10) * 10 + 9.5, Int(Y / 10) * 10 + 9.5), picPen2.BackColor, BF
 End If
End Sub

Private Sub picSprite_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
 ConverttoText
End Sub

Private Sub txtCode_DblClick()
 ConverttoPict
End Sub
